#include <bits/stdc++.h>

using namespace std;

/*bool f(const& pair<long long, int> p1,const& pair<long long, int> p2){
    return (p2.second > p1.second);
}*/

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    long long n;
    int k;
    cin >> n >> k;
    vector<pair<long long, int>> v;
    for(int i = 0; i < k; i++){
        long long t;
        cin >> t;
        v.push_back(make_pair(t, i));
    }
    sort(v.rbegin(), v.rend());
    for(int i = 0; i < k; i++){
        long long z = v[i].first;
        for(int j = i+1; j < k; j++){
            if(v[i].first%v[j].first==0)
                z ^= v[j].first;
        }
        v[i].first = z;
    }
    sort(v.begin(),v.end(), [](const pair<long long, int>& a, const pair<long long, int>& b){return a.second<b.second;});
    for(int i = 0; i < k; i++){
        cout << v[i].first << " ";
    }
    cout << endl;
    return 0;
}